(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     61554,       1715]
NotebookOptionsPosition[     55852,       1549]
NotebookOutlinePosition[     56237,       1566]
CellTagsIndexPosition[     56194,       1563]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Tensor Differential Operators", "Title",
 CellChangeTimes->{{3.657706933735057*^9, 3.657706952591447*^9}},
 TextAlignment->Center,ExpressionUUID->"f3a6fca7-7d0e-4a86-8265-aef7c2673e6c"],

Cell[TextData[{
 "A Test Notebook\n",
 StyleBox["by Rolf Sulanke", "Text"]
}], "Chapter",
 CellChangeTimes->{{3.657706964495186*^9, 3.657707004398857*^9}},
 TextAlignment->Center,ExpressionUUID->"a8fcb921-ab92-48d9-9535-dd966253c9c5"],

Cell["\<\
This is a subnotebook of the notebook RGv2.nb. First load this notebook and \
the needed Packages, then evaluate the initialization cells of RGv2.nb.
It is recommended to vary the parameters of the examples or to consider  new \
ones.
\
\>", "Text",
 CellChangeTimes->{{3.657707087390325*^9, 3.657707221781746*^9}, {
  3.657707291501483*^9, 3.657707315845174*^9}, {3.657707359413041*^9, 
  3.657707374404682*^9}, {3.657707458052128*^9, 3.6577075025561457`*^9}, {
  3.70857602488842*^9, 3.708576051879575*^9}},
 ExpressionUUID -> "1e799130-ae06-4f89-9cf9-f3959a2c9b14"],

Cell[CellGroupData[{

Cell["The Differential Operator  dd", "Section",
 CellChangeTimes->{{3.656399644018874*^9, 3.656399670106586*^9}, 
   3.656509904800658*^9, {3.657707257909429*^9, 3.657707277205471*^9}, {
   3.70858208049959*^9, 3.7085820854595633`*^9}},
 ExpressionUUID -> "ec065c75-48c3-40ee-8b22-cc84038b185b"],

Cell[BoxData[
 RowBox[{"?", "dd"}]], "Input",
 CellChangeTimes->{{3.656317474527873*^9, 3.656317475831332*^9}},
 ExpressionUUID -> "6bba00d3-f9fe-4255-899c-ba85a883f032"],

Cell[BoxData[
 RowBox[{"?", "\[CapitalGamma]"}]], "Input",
 CellChangeTimes->{{3.657265902990912*^9, 3.657265920278874*^9}},
 ExpressionUUID -> "7c2ff340-21d0-4f64-82f4-948bfc726a13"]
}, Closed]],

Cell[CellGroupData[{

Cell["The Absolute Differential", "Section",
 CellChangeTimes->{{3.657705690231291*^9, 3.6577057023352013`*^9}},
 ExpressionUUID -> "81d6a10c-c16d-4abb-a429-ba8a14a08dba"],

Cell[CellGroupData[{

Cell["The product rule, a Simple Case", "Subsubsection",
 CellChangeTimes->{{3.656513455320837*^9, 3.656513462816564*^9}, {
  3.657268547021241*^9, 
  3.6572685559249573`*^9}},ExpressionUUID->"d1bad5ca-fba8-45f0-a5d7-\
d0f6d0d8f051"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", " ", 
  RowBox[{"dim", "=", "2"}], ";", " ", 
  RowBox[{
   RowBox[{"ta", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "0", ",", "1", ",", "dim"}], "]"}]}], 
  ";", 
  RowBox[{
   RowBox[{"tb", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "0", ",", "1", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
  3.656343881485649*^9, 3.656344060278912*^9}},
 ExpressionUUID -> "a5b27434-766f-43b1-a6da-25b9bfce99c1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 3.6563973322866383`*^9}},
 ExpressionUUID -> "2014edec-8cb7-4f39-be3d-8557cb969836"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344155876411*^9, 3.6563441628832293`*^9}, {
  3.656396589788447*^9, 3.656396611524116*^9}},
 ExpressionUUID -> "c9060884-c956-4fd5-b2ec-ba2918173556"],

Cell[BoxData[
 RowBox[{"vx", "=", 
  RowBox[{"vec", "[", "\[Xi]", "]"}]}]], "Input",
 CellChangeTimes->{{3.6563441819913282`*^9, 3.656344255018395*^9}, {
  3.656402779185873*^9, 3.656402786313506*^9}, {3.7022044808249807`*^9, 
  3.702204487114913*^9}, {3.702204520519833*^9, 3.7022045286476603`*^9}},
 ExpressionUUID -> "4a1e7197-d8c5-4f18-9f8c-f88559b6ebd5"],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"tensorD", "[", 
     RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, 
   3.6572645882297373`*^9, 3.657267637365982*^9},
 ExpressionUUID -> "6815f789-da58-4858-a5cc-87591b8f8a33"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"tensorD", "[", 
       RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
      RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}], ")"}], 
   "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, 
   3.657264588230474*^9, 3.657267638974288*^9},
 ExpressionUUID -> "6b60ed1d-bf42-484c-9e7c-8680a4e5c071"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"tensorD", "[", 
       RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
      RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}], 
    ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, 
   3.657264588231209*^9, 3.657267641654131*^9},
 ExpressionUUID -> "d8ef2f79-50ca-45bb-ac98-c9c5cbcf0a1a"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 3.656397670151092*^9}},
 ExpressionUUID -> "b0261506-00fe-4620-9f2e-4fe3a4a53d10"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"dtc", ",", 
   RowBox[{"dta", " ", "+", "dtb"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}},
 ExpressionUUID -> "809dab47-7f1c-4658-b70d-ff8cbe49fa56"],

Cell[BoxData[
 RowBox[{"dtc", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.702204810071938*^9, 3.702204829100892*^9}},
 ExpressionUUID -> "d32d6a59-b1ad-4735-836d-deb1ab094c0e"],

Cell["OK!", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 
  3.6564883909065437`*^9}},ExpressionUUID->"318f4393-4e01-448d-92ca-\
31e414b61a8e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"th", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], " ", "=", 
  RowBox[{"tensor", "[", 
   RowBox[{
    RowBox[{"h", "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ",", "0", ",", "2", ",", "2"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.656409851247612*^9, 3.656409974154014*^9}},
 ExpressionUUID -> "9fe2f2f9-9d3c-4421-af70-f01465842304"],

Cell[BoxData[
 RowBox[{
  RowBox[{"th", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656409990192245*^9, 3.6564100195936413`*^9}},
 ExpressionUUID -> "e484a351-eac1-4eea-aec4-5169eced3921"],

Cell[BoxData[
 RowBox[{"dth", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"tensorD", "[", 
     RowBox[{"\[CapitalGamma]", ",", " ", "th"}], "]"}], "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}]}]], "Input",
 CellChangeTimes->{{3.656410044274021*^9, 3.656410052393404*^9}, {
   3.656410098298154*^9, 3.6564101080970097`*^9}, 3.657264588231941*^9, 
   3.65726764365377*^9},
 ExpressionUUID -> "2f953755-75dc-4fee-a67a-59c784fd05c8"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"dth", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656410127171617*^9, 3.65641018145623*^9}},
 ExpressionUUID -> "c8762378-6fb6-44a6-93a9-e15c942bdc75"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"absD", "[", 
     RowBox[{"\[CapitalGamma]", ",", " ", "th"}], "]"}], "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656410851069168*^9, 3.656410940634248*^9}, {
   3.656410983866839*^9, 3.6564109844258537`*^9}, 3.657264503398987*^9, 
   3.657267448967368*^9},
 ExpressionUUID -> "17b09bfc-9c8c-405d-a357-85aea52d97c9"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", "%%"}]], "Input",
 CellChangeTimes->{{3.656411003119673*^9, 3.656411006025104*^9}},
 ExpressionUUID -> "a9e99ace-4474-44c3-8450-46c66ba1dd68"],

Cell["OK!", "Text",
 CellChangeTimes->{{3.656488884534676*^9, 
  3.656488887078676*^9}},ExpressionUUID->"2557026c-ca74-47f7-abd3-\
508fbaa9f415"]
}, Closed]],

Cell[CellGroupData[{

Cell["The product rule, Tensors of Higher Degree", "Subsubsection",
 CellChangeTimes->{{3.656513455320837*^9, 3.656513462816564*^9}, {
  3.657268547021241*^9, 3.6572685559249573`*^9}, {3.657268591229002*^9, 
  3.6572686529004307`*^9}},ExpressionUUID->"f04e0899-2261-4b77-b8b1-\
1521e61a37e3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", " ", 
  RowBox[{"dim", "=", "3"}], ";", " ", 
  RowBox[{
   RowBox[{"ta", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "2", ",", "1", ",", "dim"}], "]"}]}], 
  ";", 
  RowBox[{
   RowBox[{"tb", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "1", ",", "2", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
   3.656343881485649*^9, 3.656344060278912*^9}, {3.657268670060849*^9, 
   3.6572687057723846`*^9}, 3.657270928587624*^9},
 ExpressionUUID -> "142ef103-6a20-4da2-941a-628d6f53151c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tensor", "[", 
   RowBox[{
    RowBox[{"b", "[", "x", "]"}], ",", "1", ",", "2", ",", "3"}], "]"}], "[", 
  
  RowBox[{
   RowBox[{"{", "2", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.702205190841815*^9, 3.7022052311611967`*^9}},
 ExpressionUUID -> "8b25ea1d-746a-4fd4-a16b-2d08cf7cbafe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 3.6563973322866383`*^9}},
 ExpressionUUID -> "44797b5f-c7bc-4d30-ac04-05bd43cb4b42"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344155876411*^9, 3.6563441628832293`*^9}, {
  3.656396589788447*^9, 3.656396611524116*^9}, {3.657268729884376*^9, 
  3.657268733628224*^9}, {3.657270956490694*^9, 3.657270962258533*^9}},
 ExpressionUUID -> "a8dc9006-ea40-4ceb-bb69-0b4155071a5a"],

Cell[BoxData[
 RowBox[{"vx", "=", 
  RowBox[{"vec", "[", "\[Xi]", "]"}]}]], "Input",
 CellChangeTimes->{{3.6563441819913282`*^9, 3.656344255018395*^9}, {
  3.656402779185873*^9, 3.656402786313506*^9}, {3.702205379057104*^9, 
  3.702205407079815*^9}},
 ExpressionUUID -> "79dee728-e320-4a2b-9dff-902868967365"],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"tensorD", "[", 
     RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, 
   3.6572645882297373`*^9, 3.657267637365982*^9},
 ExpressionUUID -> "79a2381c-725e-4233-9e21-f1ea15204e70"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"tensorD", "[", 
       RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
      RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}], ")"}], 
   "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, 
   3.657264588230474*^9, 3.657267638974288*^9},
 ExpressionUUID -> "31725c44-7648-4c9b-9ee7-c404fb822270"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"tensorD", "[", 
       RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
      RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}], 
    ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, 
   3.657264588231209*^9, 3.657267641654131*^9},
 ExpressionUUID -> "52b93c1b-305e-42e4-a0b9-571691529fd8"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 3.656397670151092*^9}},
 ExpressionUUID -> "67eb5283-1630-470c-8cc8-ed778d7d6a81"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"equi", "[", 
   RowBox[{"dtc", ",", 
    RowBox[{"dta", " ", "+", "dtb"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}, {3.657270995298828*^9, 3.6572710031541433`*^9}},
 ExpressionUUID -> "5253ae7d-81c7-42f1-b376-d86bee6fd3b8"],

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " v. 9.0.1 needed ",
 "518.292",
 " s to confirm the equivalence. \nChoose other parameters for further tests.\
\nOK!"
}], "Text",
 CellChangeTimes->{{3.656488388330553*^9, 3.6564883909065437`*^9}, {
   3.657272028530201*^9, 3.6572721171214027`*^9}, 3.702206978202754*^9, {
   3.708576735179893*^9, 3.708576784107448*^9}, 3.708583692753265*^9},
 ExpressionUUID -> "60a85169-e2ca-4bb3-8aca-9f485253f55d"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["The Gradient Tensor", "Section",
 CellChangeTimes->{{3.656491371298958*^9, 3.656491381498766*^9}, {
  3.6577060545483913`*^9, 
  3.657706060524276*^9}},ExpressionUUID->"6b91c0f0-7d9a-4234-b76f-\
b0e84f0b1af7"],

Cell[CellGroupData[{

Cell["A simple example", "Subsubsection",
 CellChangeTimes->{{3.657706561409265*^9, 
  3.657706569672962*^9}},ExpressionUUID->"fabdc4a9-5db4-4ed1-babb-\
0ec51c76d67d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", "2"}], ";", 
  RowBox[{
   RowBox[{"th", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], " ", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"h", "[", 
      RowBox[{"var", "[", "x", "]"}], "]"}], ",", "0", ",", "2", ",", "2"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656409851247612*^9, 3.656409974154014*^9}, {
  3.6565129026476107`*^9, 3.6565129069665937`*^9}},
 ExpressionUUID -> "a8a1b072-b68f-438e-bdf8-a4e79c7a6cf3"],

Cell[BoxData[
 RowBox[{"%", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.702207023665339*^9, 3.70220704364228*^9}},
 ExpressionUUID -> "fa62b22d-bcdf-4226-aac9-23c26973f616"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nabla", "[", 
   RowBox[{"\[CapitalGamma]", ",", " ", "th"}], "]"}], "[", 
  RowBox[{"var", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6565131337678547`*^9, 3.656513156372128*^9}, 
   3.657706477578019*^9, {3.7085774564683037`*^9, 3.7085774590239058`*^9}},
 ExpressionUUID -> "872e807a-25e3-415a-a9a7-9870a9cb956b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "th"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", "2", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656512765396839*^9, 3.656512832935441*^9}, {
   3.656512867407143*^9, 3.656512881758539*^9}, 3.657706281706274*^9, {
   3.7085774019873953`*^9, 3.7085774061614656`*^9}},
 ExpressionUUID -> "a1da00d6-3fe1-493a-b152-42b03bbfa220"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "ta", "]"}], ";", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", 
      RowBox[{"var", "[", "x", "]"}], "]"}], ",", "1", ",", "1", ",", "2"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65649163067452*^9, 3.656491686816806*^9}},
 ExpressionUUID -> "6078e43e-5962-4157-aa2f-e2b324f0f826"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "2", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656491697937336*^9, 3.656491718632066*^9}, {
   3.656491759233148*^9, 3.656491788183885*^9}, 3.6577062858193808`*^9, 
   3.708577560333941*^9, 3.708577809174765*^9},
 ExpressionUUID -> "89b69fb0-5cdb-4a47-ba97-6cd0628a5595"]
}, Closed]],

Cell[CellGroupData[{

Cell["The product rule for nabla 1", "Subsubsection",
 CellChangeTimes->{{3.6565133329699793`*^9, 3.656513352826008*^9}, 
   3.656513980371511*^9, {3.7085781482731543`*^9, 3.708578150792781*^9}},
 ExpressionUUID -> "1d386383-487d-41fd-98f5-5efe7bd0209a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", " ", 
  RowBox[{"dim", "=", "2"}], ";", " ", 
  RowBox[{
   RowBox[{"ta", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "0", ",", "1", ",", "dim"}], "]"}]}], 
  ";", 
  RowBox[{
   RowBox[{"tb", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "0", ",", "1", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
  3.656343881485649*^9, 3.656344060278912*^9}},
 ExpressionUUID -> "138d6761-397e-4126-aff7-0d3b525d50cf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 3.6563973322866383`*^9}},
 ExpressionUUID -> "e3acb00e-7c92-4a6d-91ce-f79abd00f229"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344155876411*^9, 3.6563441628832293`*^9}, {
  3.656396589788447*^9, 3.656396611524116*^9}},
 ExpressionUUID -> "70047adb-9030-4ad4-98b8-8e37660819a6"],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, {
   3.656513721230363*^9, 3.656513740902547*^9}, 3.657706479441453*^9, 
   3.708577684414433*^9},
 ExpressionUUID -> "b70d9527-220a-4048-9ee2-5928da2d718d"],

Cell[BoxData[
 RowBox[{"tensor", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"nabla", "[", 
     RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
    RowBox[{
     RowBox[{"x", "[", "1", "]"}], ",", 
     RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "1", ",", "2", ",", "2"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.657706287754882*^9, 3.657706287756969*^9}, 
   3.708577560337583*^9, 3.7085778091835117`*^9},
 ExpressionUUID -> "937374a7-27e6-4904-a9ce-d7241298d2f2"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, {
   3.656513779366226*^9, 3.656513793669793*^9}, 3.65770648027463*^9, 
   3.7085776844190187`*^9},
 ExpressionUUID -> "63175e5d-f7fc-4f8f-bf61-f5c89da3079d"],

Cell[BoxData[
 RowBox[{"tensor", "[", 
  RowBox[{
   RowBox[{"tp", "[", 
    RowBox[{
     RowBox[{"tensor", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"nabla", "[", 
         RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
        RowBox[{
         RowBox[{"x", "[", "1", "]"}], ",", 
         RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "1", ",", "1", ",", 
       "2"}], "]"}], ",", 
     RowBox[{"tensor", "[", 
      RowBox[{
       RowBox[{"b", "[", 
        RowBox[{
         RowBox[{"x", "[", "1", "]"}], ",", 
         RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "0", ",", "1", ",", 
       "2"}], "]"}]}], "]"}], ",", "1", ",", "2", ",", "2"}], "]"}]], "Input",\

 CellChangeTimes->{{3.657706293841281*^9, 3.65770629384379*^9}, 
   3.708577560341545*^9, 3.708577809190198*^9},
 ExpressionUUID -> "8453037f-13c2-4dd5-91b4-7966a4c6b53b"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, {
   3.6565138267978354`*^9, 3.656513852269517*^9}, 3.657706481138563*^9, 
   3.708577684422521*^9},
 ExpressionUUID -> "ef05791e-d676-4538-8ad4-0ed6092e4b5a"],

Cell[BoxData[
 RowBox[{"tensor", "[", 
  RowBox[{
   RowBox[{"tp", "[", 
    RowBox[{
     RowBox[{"tensor", "[", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{
         RowBox[{"x", "[", "1", "]"}], ",", 
         RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "0", ",", "1", ",", 
       "2"}], "]"}], ",", 
     RowBox[{"tensor", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"nabla", "[", 
         RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
        RowBox[{
         RowBox[{"x", "[", "1", "]"}], ",", 
         RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "1", ",", "1", ",", 
       "2"}], "]"}]}], "]"}], ",", "1", ",", "2", ",", "2"}], "]"}]], "Input",\

 CellChangeTimes->{{3.657706295154842*^9, 3.6577062951574297`*^9}, 
   3.708577560344819*^9, 3.708577809194604*^9},
 ExpressionUUID -> "198b73fa-bda3-4040-ab65-e3e260820d72"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 3.656397670151092*^9}},
 ExpressionUUID -> "d17198eb-5772-4c7d-a77a-e53a6bf43aea"],

Cell[BoxData[
 RowBox[{"tensor", "[", 
  RowBox[{
   RowBox[{"plus", "[", 
    RowBox[{
     RowBox[{"tp", "[", 
      RowBox[{
       RowBox[{"tensor", "[", 
        RowBox[{
         RowBox[{"a", "[", 
          RowBox[{
           RowBox[{"x", "[", "1", "]"}], ",", 
           RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "0", ",", "1", ",", 
         "2"}], "]"}], ",", 
       RowBox[{"tensor", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"nabla", "[", 
           RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
          RowBox[{
           RowBox[{"x", "[", "1", "]"}], ",", 
           RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "1", ",", "1", ",", 
         "2"}], "]"}]}], "]"}], ",", 
     RowBox[{"tp", "[", 
      RowBox[{
       RowBox[{"tensor", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"nabla", "[", 
           RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
          RowBox[{
           RowBox[{"x", "[", "1", "]"}], ",", 
           RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "1", ",", "1", ",", 
         "2"}], "]"}], ",", 
       RowBox[{"tensor", "[", 
        RowBox[{
         RowBox[{"b", "[", 
          RowBox[{
           RowBox[{"x", "[", "1", "]"}], ",", 
           RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "0", ",", "1", ",", 
         "2"}], "]"}]}], "]"}]}], "]"}], ",", "1", ",", "2", ",", "2"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.657706296575757*^9, 3.657706298659728*^9}, {
  3.70857756034848*^9, 3.708577560503264*^9}, {3.708577809200345*^9, 
  3.708577809202238*^9}},
 ExpressionUUID -> "d7f4f0cb-83ec-4c5f-9a92-e6437f12b7b8"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"dtc", ",", 
   RowBox[{"dta", " ", "+", "dtb"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}},
 ExpressionUUID -> "56d3846c-cd9a-4dfb-8af6-544cfa0b8445"],

Cell["OK!", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 
  3.6564883909065437`*^9}},ExpressionUUID->"dd39d006-10e8-4cd1-8ff9-\
bbacf6557190"]
}, Closed]],

Cell[CellGroupData[{

Cell["The product rule for nabla 2", "Subsubsection",
 CellChangeTimes->{{3.6565133329699793`*^9, 3.656513352826008*^9}, 
   3.656513980371511*^9, 3.656514039474928*^9, {3.70857826568954*^9, 
   3.708578267841106*^9}},
 ExpressionUUID -> "d725f788-5c80-4201-84c9-89415a0e7ac2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", " ", 
  RowBox[{"dim", "=", "2"}], ";", 
  RowBox[{"pa", "=", "1"}], ";", 
  RowBox[{"qa", "=", "1"}], " ", ";", 
  RowBox[{
   RowBox[{"ta", "[", "x__", "]"}], "  ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "pa", ",", "qa", ",", "dim"}], 
    "]"}]}], ";", 
  RowBox[{"pb", "=", "1"}], ";", 
  RowBox[{"qb", "=", "0"}], ";", 
  RowBox[{
   RowBox[{"tb", "[", "x__", "]"}], "  ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "pb", ",", "qb", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
   3.656343881485649*^9, 3.656344060278912*^9}, {3.656514084011107*^9, 
   3.656514153602344*^9}, {3.6565141909062634`*^9, 3.656514240371709*^9}, 
   3.708578773412945*^9, 3.708578808371447*^9, {3.708579246979186*^9, 
   3.7085792876523457`*^9}},
 ExpressionUUID -> "b95c85a3-f448-45ee-b332-9a72aa910264"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "tc", "]"}], ";", 
  RowBox[{
   RowBox[{"tc", "[", "x__", "]"}], ":=", " ", 
   RowBox[{
    RowBox[{"ta", "[", "x", "]"}], "\[CircleTimes]", 
    RowBox[{"tb", "[", "x", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 3.6563973322866383`*^9}, {
   3.708578829730301*^9, 3.7085788457540207`*^9}, {3.708579067750903*^9, 
   3.708579107406444*^9}, {3.708579313535179*^9, 3.7085793430542803`*^9}},
 ExpressionUUID -> "fffd1fe0-d2f6-4adb-8e45-579cbd3e5120"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "2", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.708579132115157*^9, 3.708579155158023*^9}}],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, {
   3.656513721230363*^9, 3.656513740902547*^9}, 3.657706481992667*^9, 
   3.7085776844284067`*^9, 3.7085789393292627`*^9, {3.708579010705134*^9, 
   3.708579023552812*^9}, {3.708579388582595*^9, 3.708579411757415*^9}},
 ExpressionUUID -> "0a9eb9a0-98f7-42c3-b28d-77f443f90dbd"],

Cell[BoxData[
 RowBox[{"dtc", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "1", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.708579431040156*^9, 3.7085794509490433`*^9}}],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, {
   3.656513779366226*^9, 3.656513793669793*^9}, 3.657706482818408*^9, 
   3.708577684434054*^9, {3.708578972785952*^9, 3.7085789856497507`*^9}, {
   3.708579215703829*^9, 3.708579222521091*^9}, {3.708579488006474*^9, 
   3.7085794954065638`*^9}},
 ExpressionUUID -> "a2f8b185-5ebe-4d9a-9668-05591424d573"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, {
   3.6565138267978354`*^9, 3.656513852269517*^9}, 3.657706483552514*^9, 
   3.708577684439376*^9},
 ExpressionUUID -> "30efbd99-35f6-47ee-9d5e-290f9b7c0b65"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 3.656397670151092*^9}},
 ExpressionUUID -> "404b0059-c2ca-4c20-9752-e699fecbfe74"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"dtc", ",", 
   RowBox[{"dta", " ", "+", "dtb"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}},
 ExpressionUUID -> "ff3f9177-4033-4608-a98d-6373ae7f935a"],

Cell["Product rule isn\[CloseCurlyQuote]t confirmed!", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 3.6564883909065437`*^9}, {
  3.6565145076063423`*^9, 
  3.656514530414145*^9}},ExpressionUUID->"d57be9ca-8822-4bff-8300-\
163907fbeb0e"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"coords", "[", 
   RowBox[{"dtc", "-", "dta", "-", "dtb"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656514538895512*^9, 3.656514589149849*^9}, 
   3.656514624694223*^9},
 ExpressionUUID -> "8a54803d-ae31-42e6-b5a9-53df48b042e8"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7085795988528013`*^9, 3.708579612291287*^9}}],

Cell[BoxData[
 RowBox[{"diff", "=", " ", 
  RowBox[{"dtc", "-", "dta", "-", "dtb"}]}]], "Input",
 CellChangeTimes->{{3.656514730285493*^9, 3.656514740277762*^9}},
 ExpressionUUID -> "983f8e62-eaf2-4525-be2c-a8819976134a"],

Cell[BoxData[
 RowBox[{"tensor", "[", 
  RowBox[{
   RowBox[{"plus", "[", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"tp", "[", 
       RowBox[{
        RowBox[{"tensor", "[", 
         RowBox[{
          RowBox[{"a", "[", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], ",", 
            RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "1", ",", "1", ",", 
          "2"}], "]"}], ",", 
        RowBox[{"tensor", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"nabla", "[", 
            RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], ",", 
            RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "2", ",", "0", ",", 
          "2"}], "]"}]}], "]"}]}], ",", 
     RowBox[{"-", 
      RowBox[{"tp", "[", 
       RowBox[{
        RowBox[{"tensor", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"nabla", "[", 
            RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], ",", 
            RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "2", ",", "1", ",", 
          "2"}], "]"}], ",", 
        RowBox[{"tensor", "[", 
         RowBox[{
          RowBox[{"b", "[", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], ",", 
            RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "1", ",", "0", ",", 
          "2"}], "]"}]}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"nabla", "[", 
       RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
      RowBox[{
       RowBox[{"x", "[", "1", "]"}], ",", 
       RowBox[{"x", "[", "2", "]"}]}], "]"}]}], "]"}], ",", "3", ",", "1", 
   ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.657706305514587*^9, 3.657706307482524*^9}, {
  3.7085775606925383`*^9, 3.708577560858514*^9}, {3.708577809544366*^9, 
  3.70857780955262*^9}},
 ExpressionUUID -> "392a5ed5-a664-4442-8345-a69527fce191"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"diff", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
    RowBox[{"{", "2", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656514752369658*^9, 3.656514878171894*^9}},
 ExpressionUUID -> "3fb524e4-d64d-49d1-8681-9a60dcb9e4c7"]
}, Closed]],

Cell[CellGroupData[{

Cell["The product rule for nabla 3", "Subsubsection",
 CellChangeTimes->{{3.6565133329699793`*^9, 3.656513352826008*^9}, 
   3.656513980371511*^9, 3.656514039474928*^9, 3.656515000794417*^9, {
   3.708579653878467*^9, 3.7085796564468412`*^9}},
 ExpressionUUID -> "8577e29a-bdf6-405f-9b91-ab7a040ca122"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", " ", 
  RowBox[{"dim", "=", "2"}], ";", 
  RowBox[{"pa", "=", "1"}], ";", 
  RowBox[{"qa", "=", "0"}], " ", ";", 
  RowBox[{
   RowBox[{"ta", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "pa", ",", "qa", ",", "dim"}], 
    "]"}]}], ";", 
  RowBox[{"pb", "=", "1"}], ";", 
  RowBox[{"qb", "=", "0"}], ";", 
  RowBox[{
   RowBox[{"tb", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "pb", ",", "qb", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
   3.656343881485649*^9, 3.656344060278912*^9}, {3.656514084011107*^9, 
   3.656514153602344*^9}, {3.6565141909062634`*^9, 3.656514240371709*^9}, 
   3.656515035699079*^9},
 ExpressionUUID -> "87929b81-5d50-4821-9c38-f3af9ac2e3c3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 3.6563973322866383`*^9}},
 ExpressionUUID -> "ba38c149-e4a2-46c0-ab21-bed6a76625c5"],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, {
   3.656513721230363*^9, 3.656513740902547*^9}, 3.65770648430613*^9, 
   3.708577684443774*^9},
 ExpressionUUID -> "0d59b217-6195-460a-aed5-de4306574cff"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, {
   3.656513779366226*^9, 3.656513793669793*^9}, 3.657706485041752*^9, 
   3.708577684447927*^9},
 ExpressionUUID -> "256d16a3-ef17-4a6e-99b5-e5c6f7cdf203"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, {
   3.6565138267978354`*^9, 3.656513852269517*^9}, 3.657706485712727*^9, 
   3.708577684452478*^9},
 ExpressionUUID -> "399d7294-0692-426b-96c8-08b98a0cefd8"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 3.656397670151092*^9}},
 ExpressionUUID -> "0a18299e-9f3a-4895-a5b7-23f31991020f"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"dtc", ",", 
   RowBox[{"dta", " ", "+", "dtb"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}},
 ExpressionUUID -> "f68cfd10-cbb7-45a7-93ed-b52cab39ddf7"],

Cell["Product rule isn\[CloseCurlyQuote]t confirmed!", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 3.6564883909065437`*^9}, {
  3.6565145076063423`*^9, 
  3.656514530414145*^9}},ExpressionUUID->"cacc6a59-32d8-4dd9-9619-\
bd80606772ae"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"coords", "[", 
   RowBox[{"dtc", "-", "dta", "-", "dtb"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656514538895512*^9, 3.656514589149849*^9}, 
   3.656514624694223*^9},
 ExpressionUUID -> "e0e73618-785a-42ab-86fd-10f74608374c"],

Cell[BoxData[
 RowBox[{"diff", "=", " ", 
  RowBox[{"dtc", "-", "dta", "-", "dtb"}]}]], "Input",
 CellChangeTimes->{{3.656514730285493*^9, 3.656514740277762*^9}},
 ExpressionUUID -> "d2df96d0-d727-4479-a1ab-7d8ecb78f6dd"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"diff", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656514752369658*^9, 3.656514878171894*^9}, 
   3.656515122953247*^9},
 ExpressionUUID -> "2287ca22-b680-472d-9c77-e3c8c1d91a71"]
}, Closed]],

Cell[CellGroupData[{

Cell["The product rule for nabla 4", "Subsubsection",
 CellChangeTimes->{{3.6565133329699793`*^9, 3.656513352826008*^9}, 
   3.656513980371511*^9, 3.656514039474928*^9, 3.656515000794417*^9, 
   3.656515253256382*^9, {3.70857970597388*^9, 3.708579708102652*^9}},
 ExpressionUUID -> "c96ad5bf-0af6-40b2-9734-7b12909e53ad"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", " ", 
  RowBox[{"dim", "=", "2"}], ";", 
  RowBox[{"pa", "=", "1"}], ";", 
  RowBox[{"qa", "=", "0"}], " ", ";", 
  RowBox[{
   RowBox[{"ta", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "pa", ",", "qa", ",", "dim"}], 
    "]"}]}], ";", 
  RowBox[{"pb", "=", "0"}], ";", 
  RowBox[{"qb", "=", "0"}], ";", 
  RowBox[{
   RowBox[{"tb", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "pb", ",", "qb", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
   3.656343881485649*^9, 3.656344060278912*^9}, {3.656514084011107*^9, 
   3.656514153602344*^9}, {3.6565141909062634`*^9, 3.656514240371709*^9}, 
   3.656515035699079*^9, 3.6565152780806026`*^9},
 ExpressionUUID -> "057320c2-c4c8-4af6-bf78-ad20bdac0baf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 3.6563973322866383`*^9}},
 ExpressionUUID -> "cd119653-ed32-4395-b2e7-95e1c46e1500"],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, {
   3.656513721230363*^9, 3.656513740902547*^9}, 3.657706486490097*^9, 
   3.708577684457518*^9},
 ExpressionUUID -> "be240fb3-63b8-4474-8d27-33187182fe0c"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, {
   3.656513779366226*^9, 3.656513793669793*^9}, 3.657706487234462*^9, 
   3.7085776844613743`*^9},
 ExpressionUUID -> "ccb3e72a-f977-4ccb-9e1d-2afeae2c21e2"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, {
   3.6565138267978354`*^9, 3.656513852269517*^9}, 3.657706487946682*^9, 
   3.708577684465144*^9},
 ExpressionUUID -> "ffa6746b-6a97-43ad-ba17-3c4e7018f39a"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 3.656397670151092*^9}},
 ExpressionUUID -> "54a5159a-365a-4ff6-87ee-8cdd2070b21e"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"dtc", ",", 
   RowBox[{"dta", " ", "+", "dtb"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}},
 ExpressionUUID -> "66b236dc-ec83-49ce-b6d8-25c16028ad39"],

Cell["Product rule is confirmed!", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 3.6564883909065437`*^9}, {
   3.6565145076063423`*^9, 3.656514530414145*^9}, 
   3.6565153296395206`*^9},ExpressionUUID->"6997348e-b067-44cc-b2ce-\
c8016e317a9d"]
}, Closed]],

Cell[CellGroupData[{

Cell["The product rule for nabla 5", "Subsubsection",
 CellChangeTimes->{{3.6565133329699793`*^9, 3.656513352826008*^9}, 
   3.656513980371511*^9, 3.656514039474928*^9, 3.656515000794417*^9, 
   3.656515253256382*^9, 3.656515382127493*^9, {3.708579776886148*^9, 
   3.708579779221105*^9}},
 ExpressionUUID -> "5e4c78fb-c5e4-42bb-9127-1c29ebdf94ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", " ", 
  RowBox[{"dim", "=", "2"}], ";", 
  RowBox[{"pa", "=", "0"}], ";", 
  RowBox[{"qa", "=", "0"}], " ", ";", 
  RowBox[{
   RowBox[{"ta", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "pa", ",", "qa", ",", "dim"}], 
    "]"}]}], ";", 
  RowBox[{"pb", "=", "1"}], ";", 
  RowBox[{"qb", "=", "0"}], ";", 
  RowBox[{
   RowBox[{"tb", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "pb", ",", "qb", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
   3.656343881485649*^9, 3.656344060278912*^9}, {3.656514084011107*^9, 
   3.656514153602344*^9}, {3.6565141909062634`*^9, 3.656514240371709*^9}, 
   3.656515035699079*^9, 3.6565152780806026`*^9, {3.656515407831373*^9, 
   3.656515426952744*^9}},
 ExpressionUUID -> "a775cf17-e4e6-425c-a09c-394ff779ff96"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 3.6563973322866383`*^9}},
 ExpressionUUID -> "bc661ef8-b6d0-4804-afbf-0b7c71a7f3bc"],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, {
   3.656513721230363*^9, 3.656513740902547*^9}, 3.657706488681872*^9, 
   3.708577684478401*^9},
 ExpressionUUID -> "06f84df1-f4e5-4a47-bc8b-edf65cff43c4"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, {
   3.656513779366226*^9, 3.656513793669793*^9}, 3.657706489330159*^9, 
   3.708577684490494*^9},
 ExpressionUUID -> "8241247b-1966-4359-98b7-91dbf035b49d"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, {
   3.6565138267978354`*^9, 3.656513852269517*^9}, 3.6577064901262417`*^9, 
   3.708577684501904*^9},
 ExpressionUUID -> "c6b61053-1db3-4e4b-8cc2-93f3011b10b7"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 3.656397670151092*^9}},
 ExpressionUUID -> "f0df06b9-6a4b-45fa-aeef-853e1bb4ef35"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"dtc", ",", 
   RowBox[{"dta", " ", "+", "dtb"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}},
 ExpressionUUID -> "70d2f52c-1cf5-42df-aefa-0623a4bcee73"],

Cell["Product rule isn\[CloseCurlyQuote]t confirmed!", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 3.6564883909065437`*^9}, {
   3.6565145076063423`*^9, 3.656514530414145*^9}, 3.6565153296395206`*^9, {
   3.656515512150305*^9, 
   3.6565155153100653`*^9}},ExpressionUUID->"3879f509-6d82-4eb1-9011-\
bd852be4c95b"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"coords", "[", 
   RowBox[{"dtc", "-", "dta", "-", "dtb"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656514538895512*^9, 3.656514589149849*^9}, 
   3.656514624694223*^9},
 ExpressionUUID -> "fa8634d7-c9b4-4d5e-8f79-28fbc4dc36b0"],

Cell[BoxData[
 RowBox[{"diff", "=", " ", 
  RowBox[{"dtc", "-", "dta", "-", "dtb"}]}]], "Input",
 CellChangeTimes->{{3.656514730285493*^9, 3.656514740277762*^9}},
 ExpressionUUID -> "7e44644b-29a1-4923-87df-dbb9a04e8a32"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"diff", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656514752369658*^9, 3.656514878171894*^9}, 
   3.656515122953247*^9, 3.656515563470653*^9},
 ExpressionUUID -> "ea191526-5dfa-4897-8dcd-a7d168e72f8d"]
}, Closed]],

Cell[CellGroupData[{

Cell["Investigate!", "Subsubsection",
 CellChangeTimes->{{3.656515750700324*^9, 
  3.656515765460084*^9}},ExpressionUUID->"60646a9c-869d-4791-85be-\
7c38f486f2e9"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"coords", "[", 
   RowBox[{"dtc", "-", "dta", "-", "dtb"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656514538895512*^9, 3.656514589149849*^9}, 
   3.656514624694223*^9},
 ExpressionUUID -> "b9c1e59d-8fec-40dd-969c-d1aa80fc0777"],

Cell[BoxData[
 RowBox[{"diff", "=", " ", 
  RowBox[{"dtc", "-", "dta", "-", "dtb"}]}]], "Input",
 CellChangeTimes->{{3.656514730285493*^9, 3.656514740277762*^9}},
 ExpressionUUID -> "e204bd45-ab79-41f7-ade3-cec75119af70"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"diff", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656514752369658*^9, 3.656514878171894*^9}, 
   3.656515122953247*^9, 3.656515563470653*^9},
 ExpressionUUID -> "7047d29c-b0fc-49a7-99d0-dfc4c2f29e6f"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The Product Rule for the Gradient Tensor of Contravariant Factors\
\>", "Subsubsection",
 CellChangeTimes->{{3.6565133329699793`*^9, 3.656513352826008*^9}, 
   3.656513980371511*^9, 3.656514039474928*^9, 3.656515000794417*^9, 
   3.656515253256382*^9, 3.656515382127493*^9, {3.656515649764855*^9, 
   3.656515661788837*^9}, {3.656601628188283*^9, 3.656601628812388*^9}, {
   3.708579881749504*^9, 3.708579930716969*^9}},
 ExpressionUUID -> "e82824d8-2fdc-4276-b067-2942a38bf698"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", " ", 
  RowBox[{"dim", "=", "4"}], ";", 
  RowBox[{"pa", "=", "0"}], ";", 
  RowBox[{"qa", "=", "2"}], " ", ";", 
  RowBox[{
   RowBox[{"ta", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "pa", ",", "qa", ",", "dim"}], 
    "]"}]}], ";", 
  RowBox[{"pb", "=", "0"}], ";", 
  RowBox[{"qb", "=", "3"}], ";", 
  RowBox[{
   RowBox[{"tb", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "pb", ",", "qb", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
   3.656343881485649*^9, 3.656344060278912*^9}, {3.656514084011107*^9, 
   3.656514153602344*^9}, {3.6565141909062634`*^9, 3.656514240371709*^9}, 
   3.656515035699079*^9, 3.6565152780806026`*^9, {3.656515407831373*^9, 
   3.656515426952744*^9}, {3.6565156988133583`*^9, 3.6565157178534117`*^9}, {
   3.656515835845417*^9, 3.6565158645163517`*^9}, 3.656515897882958*^9, 
   3.656565374592641*^9, 3.6565655833209248`*^9, 3.656587448877404*^9, 
   3.656587980713725*^9, {3.6565899538816767`*^9, 3.656589961241885*^9}, 
   3.656595591727523*^9, {3.656598153297915*^9, 3.656598166345847*^9}, 
   3.65659936882414*^9},
 ExpressionUUID -> "973d820f-d9d4-4cb6-bbde-ad82536e119b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 3.6563973322866383`*^9}},
 ExpressionUUID -> "1b48f3e0-8d36-46da-8dbc-49eb1607b24c"],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, {
   3.656513721230363*^9, 3.656513740902547*^9}, 3.657706490770233*^9, 
   3.708577684513154*^9},
 ExpressionUUID -> "3e15eb84-2147-47e8-9d8c-db6ed346ba7f"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, {
   3.656513779366226*^9, 3.656513793669793*^9}, 3.6577064914260187`*^9, 
   3.7085776845249233`*^9},
 ExpressionUUID -> "54d36b85-af96-48e4-b753-653d867bf937"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, {
   3.6565138267978354`*^9, 3.656513852269517*^9}, 3.657706492194504*^9, 
   3.70857768453636*^9},
 ExpressionUUID -> "1c2cbbc5-d4b3-4991-acad-6660bf51548c"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 3.656397670151092*^9}},
 ExpressionUUID -> "14f2db35-0126-4203-8dd8-b4ce5328a567"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"Simplify", "[", 
   RowBox[{"equi", "[", 
    RowBox[{"dtc", ",", 
     RowBox[{"dta", " ", "+", "dtb"}]}], "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}, {3.656565409384877*^9, 3.6565654391120768`*^9}},
 ExpressionUUID -> "bb140edf-00c0-43ac-b8c4-cc1f4a24d624"],

Cell["\<\
Product rule for the tensor product of contravariant tensors is confirmed for \
many examples. The last example with \
\>", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 3.6564883909065437`*^9}, {
   3.6565145076063423`*^9, 3.656514530414145*^9}, 3.6565153296395206`*^9, {
   3.656515512150305*^9, 3.6565155153100653`*^9}, 3.656515811172065*^9, {
   3.656516042625375*^9, 3.6565161170169*^9}, {3.656521092264647*^9, 
   3.656521126048506*^9}, {3.656598093617725*^9, 3.65659813411277*^9}, {
   3.6566010406643353`*^9, 
   3.656601172658983*^9}},ExpressionUUID->"5ce71f58-5f44-4e8d-8124-\
dc4845ed2464"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", 
  RowBox[{"dim", "=", "4"}], ";", 
  RowBox[{"pa", "=", "0"}], ";", 
  RowBox[{"qa", "=", "2"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ta", "[", "x__", "]"}], "=", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "pa", ",", "qa", ",", "dim"}], 
    "]"}]}], ";", 
  RowBox[{"pb", "=", "0"}], ";", 
  RowBox[{"qb", "=", "3"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"tb", "[", "x__", "]"}], "=", 
  RowBox[{"tensor", "[", 
   RowBox[{
    RowBox[{"b", "[", "x", "]"}], ",", "pb", ",", "qb", ",", "dim"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.6566014199974337`*^9, 3.656601419999034*^9}},
 ExpressionUUID -> "98fea9c6-bf4e-4c95-bb49-cc3e00f51916"],

Cell["\<\
needed 24 min on my workstation.
Choose arbitrary parameters dim, qa, qb and repeat evaluating this subsection.\
\>", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 3.6564883909065437`*^9}, {
   3.6565145076063423`*^9, 3.656514530414145*^9}, 3.6565153296395206`*^9, {
   3.656515512150305*^9, 3.6565155153100653`*^9}, 3.656515811172065*^9, {
   3.656516042625375*^9, 3.6565161170169*^9}, {3.656521092264647*^9, 
   3.656521126048506*^9}, {3.656598093617725*^9, 3.65659813411277*^9}, {
   3.6566010406643353`*^9, 3.656601172658983*^9}, {3.656601439693842*^9, 
   3.65660144758989*^9}, {3.656601538477417*^9, 
   3.65660155666113*^9}},ExpressionUUID->"405c738c-86fd-422a-a79a-\
73b33ca06f94"]
}, Closed]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1280, 651},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
Magnification:>2. Inherited,
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 191, 2, 179, "Title"],
Cell[774, 26, 234, 5, 87, "Chapter"],
Cell[1011, 33, 578, 11, 170, "Text"],
Cell[CellGroupData[{
Cell[1614, 48, 296, 4, 157, "Section"],
Cell[1913, 54, 170, 3, 93, "Input"],
Cell[2086, 59, 183, 3, 93, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[2306, 67, 171, 2, 93, "Section"],
Cell[CellGroupData[{
Cell[2502, 73, 233, 4, 66, "Subsubsection"],
Cell[2738, 79, 707, 19, 101, "Input"],
Cell[3448, 100, 473, 11, 61, "Input"],
Cell[3924, 113, 381, 10, 61, "Input"],
Cell[4308, 125, 359, 6, 61, "Input"],
Cell[4670, 133, 398, 9, 61, "Input"],
Cell[5071, 144, 532, 14, 61, "Input"],
Cell[5606, 160, 534, 14, 61, "Input"],
Cell[6143, 176, 185, 3, 61, "Input"],
Cell[6331, 181, 342, 7, 61, "Input"],
Cell[6676, 190, 272, 7, 61, "Input"],
Cell[6951, 199, 147, 3, 59, "Text"],
Cell[7101, 204, 383, 10, 61, "Input"],
Cell[7487, 216, 332, 9, 61, "Input"],
Cell[7822, 227, 457, 10, 61, "Input"],
Cell[8282, 239, 314, 8, 61, "Input"],
Cell[8599, 249, 539, 14, 61, "Input"],
Cell[9141, 265, 182, 3, 61, "Input"],
Cell[9326, 270, 145, 3, 59, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[9508, 278, 292, 4, 50, "Subsubsection"],
Cell[9803, 284, 782, 20, 133, "Input"],
Cell[10588, 306, 387, 11, 93, "Input"],
Cell[10978, 319, 473, 11, 93, "Input"],
Cell[11454, 332, 526, 12, 93, "Input"],
Cell[11983, 346, 309, 6, 93, "Input"],
Cell[12295, 354, 398, 9, 93, "Input"],
Cell[12696, 365, 532, 14, 93, "Input"],
Cell[13231, 381, 534, 14, 93, "Input"],
Cell[13768, 397, 185, 3, 93, "Input"],
Cell[13956, 402, 425, 8, 93, "Input"],
Cell[14384, 412, 469, 11, 135, "Text"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14902, 429, 215, 4, 157, "Section"],
Cell[CellGroupData[{
Cell[15142, 437, 167, 3, 66, "Subsubsection"],
Cell[15312, 442, 491, 13, 93, "Input"],
Cell[15806, 457, 269, 7, 93, "Input"],
Cell[16078, 466, 363, 7, 93, "Input"],
Cell[16444, 475, 538, 13, 93, "Input"],
Cell[16985, 490, 445, 12, 93, "Input"],
Cell[17433, 504, 534, 13, 93, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[18004, 522, 254, 3, 51, "Subsubsection"],
Cell[18261, 527, 707, 19, 133, "Input"],
Cell[18971, 548, 473, 11, 93, "Input"],
Cell[19447, 561, 381, 10, 93, "Input"],
Cell[19831, 573, 411, 9, 93, "Input"],
Cell[20245, 584, 476, 12, 93, "Input"],
Cell[20724, 598, 542, 13, 93, "Input"],
Cell[21269, 613, 865, 24, 133, "Input"],
Cell[22137, 639, 544, 13, 93, "Input"],
Cell[22684, 654, 868, 24, 133, "Input"],
Cell[23555, 680, 185, 3, 93, "Input"],
Cell[23743, 685, 1634, 45, 250, "Input"],
Cell[25380, 732, 342, 7, 93, "Input"],
Cell[25725, 741, 147, 3, 59, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[25909, 749, 277, 4, 51, "Subsubsection"],
Cell[26189, 755, 1040, 26, 172, "Input"],
Cell[27232, 783, 591, 12, 93, "Input"],
Cell[27826, 797, 276, 8, 93, "Input"],
Cell[28105, 807, 533, 10, 93, "Input"],
Cell[28641, 819, 230, 6, 93, "Input"],
Cell[28874, 827, 691, 15, 93, "Input"],
Cell[29568, 844, 544, 13, 93, "Input"],
Cell[30115, 859, 185, 3, 93, "Input"],
Cell[30303, 864, 342, 7, 93, "Input"],
Cell[30648, 873, 241, 4, 59, "Text"],
Cell[30892, 879, 289, 6, 93, "Input"],
Cell[31184, 887, 133, 2, 93, "Input"],
Cell[31320, 891, 221, 4, 93, "Input"],
Cell[31544, 897, 1933, 53, 328, "Input"],
Cell[33480, 952, 331, 8, 93, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[33848, 965, 302, 4, 51, "Subsubsection"],
Cell[34153, 971, 974, 25, 172, "Input"],
Cell[35130, 998, 473, 11, 93, "Input"],
Cell[35606, 1011, 410, 9, 93, "Input"],
Cell[36019, 1022, 541, 13, 93, "Input"],
Cell[36563, 1037, 544, 13, 93, "Input"],
Cell[37110, 1052, 185, 3, 93, "Input"],
Cell[37298, 1057, 342, 7, 93, "Input"],
Cell[37643, 1066, 241, 4, 59, "Text"],
Cell[37887, 1072, 289, 6, 93, "Input"],
Cell[38179, 1080, 221, 4, 93, "Input"],
Cell[38403, 1086, 352, 9, 93, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[38792, 1100, 321, 4, 51, "Subsubsection"],
Cell[39116, 1106, 998, 25, 172, "Input"],
Cell[40117, 1133, 473, 11, 77, "Input"],
Cell[40593, 1146, 411, 9, 93, "Input"],
Cell[41007, 1157, 543, 13, 93, "Input"],
Cell[41553, 1172, 544, 13, 93, "Input"],
Cell[42100, 1187, 185, 3, 93, "Input"],
Cell[42288, 1192, 342, 7, 93, "Input"],
Cell[42633, 1201, 247, 4, 59, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[42917, 1210, 348, 5, 51, "Subsubsection"],
Cell[43268, 1217, 1048, 26, 172, "Input"],
Cell[44319, 1245, 473, 11, 93, "Input"],
Cell[44795, 1258, 411, 9, 93, "Input"],
Cell[45209, 1269, 541, 13, 93, "Input"],
Cell[45753, 1284, 546, 13, 93, "Input"],
Cell[46302, 1299, 185, 3, 93, "Input"],
Cell[46490, 1304, 342, 7, 93, "Input"],
Cell[46835, 1313, 319, 5, 59, "Text"],
Cell[47157, 1320, 289, 6, 93, "Input"],
Cell[47449, 1328, 221, 4, 93, "Input"],
Cell[47673, 1334, 364, 9, 93, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[48074, 1348, 163, 3, 50, "Subsubsection"],
Cell[48240, 1353, 289, 6, 93, "Input"],
Cell[48532, 1361, 221, 4, 93, "Input"],
Cell[48756, 1367, 364, 9, 93, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[49157, 1381, 489, 8, 94, "Subsubsection"],
Cell[49649, 1391, 1415, 31, 172, "Input"],
Cell[51067, 1424, 473, 11, 93, "Input"],
Cell[51543, 1437, 411, 9, 93, "Input"],
Cell[51957, 1448, 545, 13, 93, "Input"],
Cell[52505, 1463, 543, 13, 93, "Input"],
Cell[53051, 1478, 185, 3, 93, "Input"],
Cell[53239, 1483, 463, 9, 93, "Input"],
Cell[53705, 1494, 615, 11, 96, "Text"],
Cell[54323, 1507, 783, 23, 172, "Input"],
Cell[55109, 1532, 703, 12, 96, "Text"]
}, Closed]]
}, Open  ]]
}, Open  ]]
}
]
*)

